#include "MotionDetection.h"

MotionDetection::MotionDetection(){//:handler(FSPI){
    handler = new SPIClass(FSPI);
};

void MotionDetection::begin(void){
     pinMode(34,OUTPUT);
     digitalWrite(34,HIGH);
     handler->begin(36,37,35,34);
    
     
     //handler->beginTransaction(SPISettings(frequency,SPI_MSBFIRST,SPI_MODE0));
     
    digitalWrite(34,LOW);
        // set Accel and Gyroscop to Low Noise
        handler->transfer(0x1F);
        handler->transfer(0x0F);
        //busy Wait for startup 
        delayMicroseconds(200);
        
    digitalWrite(34,HIGH);
     //handler->endTransaction();*/
};
void MotionDetection::end(void){
    handler->beginTransaction(SPISettings(frequency,SPI_MSBFIRST,SPI_MODE0));
    digitalWrite(34,LOW);
    handler->transfer(cmdWrite(PWR_MGMT0));
    //turn Accel and Gyroscope off
    handler->transfer(0x00);
    digitalWrite(34,HIGH);
    handler->end();
};
IMUResult MotionDetection::getAcceleration(){
    IMUResult result;
    handler->beginTransaction(SPISettings(frequency,SPI_MSBFIRST,SPI_MODE0));
    digitalWrite(34,LOW);
    result.x = handler->transfer16(cmdRead(ACCEL_DATA_X_HIGH,ACCEL_DATA_X_LOW));
    result.y = handler->transfer16(cmdRead(ACCEL_DATA_Y_HIGH,ACCEL_DATA_Y_LOW));
    result.z = handler->transfer16(cmdRead(ACCEL_DATA_Z_HIGH,ACCEL_DATA_Z_LOW));
    digitalWrite(34,HIGH);
    handler->endTransaction();
    return result;
};
IMUResult MotionDetection::getRotation(){
    IMUResult result;
    handler->beginTransaction(SPISettings(frequency,SPI_MSBFIRST,SPI_MODE0));
    digitalWrite(34,LOW);
    result.x = handler->transfer16(cmdRead(GYRO_DATA_X_HIGH,GYRO_DATA_X_LOW));
    result.y = handler->transfer16(cmdRead(GYRO_DATA_Y_HIGH,GYRO_DATA_Y_LOW));
    result.z = handler->transfer16(cmdRead(GYRO_DATA_Z_HIGH,GYRO_DATA_Z_LOW));
    digitalWrite(34,HIGH);
    handler->endTransaction();
    return result;
};
float MotionDetection::getTemperature(){
    handler->beginTransaction(SPISettings(frequency,SPI_MSBFIRST,SPI_MODE0));
    digitalWrite(34,LOW);
    handler -> write(cmdRead(REG_TEMP_HIGH,REG_TEMP_LOW));
    int16_t raw_temperatur = handler->transfer16(cmdRead(REG_TEMP_HIGH,REG_TEMP_LOW));
    
    digitalWrite(34,HIGH);
    handler->endTransaction(); 
    return raw_temperatur/128 +25;
};

int8_t MotionDetection::getWhoAmI(){
    return readRegister(WHO_AM_I);    
};



uint16_t MotionDetection::cmdRead(uint8_t regHigh,uint8_t regLow){
    return (CMD_READ | (regHigh & ADDR_MASK))<<8 & (CMD_READ | regLow & ADDR_MASK); 
};
uint16_t MotionDetection::cmdWrite(uint8_t regHigh,uint8_t regLow){
    return (CMD_WRITE | (regHigh & ADDR_MASK))<<8 & (CMD_WRITE | regLow & ADDR_MASK);
};
uint8_t MotionDetection::cmdRead(uint8_t reg){
    return (CMD_READ | (reg & ADDR_MASK));
};
uint8_t MotionDetection::cmdWrite(uint8_t reg){
    return (CMD_WRITE | (reg & ADDR_MASK));
};

int8_t MotionDetection::readRegister(uint8_t reg){
    handler->beginTransaction(SPISettings(frequency,SPI_MSBFIRST,SPI_MODE0));
    digitalWrite(34,LOW);
    uint8_t result;
    result = handler->transfer(cmdRead(reg));
    result = handler->transfer(0x00);
     digitalWrite(34,HIGH);
    handler->endTransaction(); 
    return result;
};

int16_t MotionDetection::readDoubleRegister(uint8_t lowerReg){
    return 0;
}